//------------------------------------------------------------------
#property copyright ""
#property link      ""
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 3
#property indicator_plots   3
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_type1   DRAW_HISTOGRAM
#property indicator_type2   DRAW_HISTOGRAM


input string EmaPeriods_ = "1,50;2,100;3,200";

double GreenBuffer[];
double RedBuffer[];
double trend[];
int periods[][2];
int    size;
int macd[];
string EmaPeriods;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void OnInit()
{
   //IndicatorBuffers(3);
   EmaPeriods = EmaPeriods_;
   ArraySetAsSeries(GreenBuffer,true); 
   ArraySetAsSeries(RedBuffer,true);
   ArraySetAsSeries(trend,true);
    
   SetIndexBuffer(0,GreenBuffer,INDICATOR_DATA); //SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,RedBuffer,INDICATOR_DATA);   //SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend,INDICATOR_CALCULATIONS);

      //
      //
      //
      //
      //
         
      if (StringSubstr(EmaPeriods,StringLen(EmaPeriods)-1,1) != ";")
                       EmaPeriods = ""+EmaPeriods+";";
         int    s = 0;
         int    i = StringFind(EmaPeriods,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(EmaPeriods,s,i-s);
                     ArrayResize(periods,ArrayRange(periods,0)+1);
                                 int k = StringFind(current,",");
                                 periods[ArrayRange(periods,0)-1][0] = (int)(StringSubstr(current,0,k));
                                 periods[ArrayRange(periods,0)-1][1] = (int)(StringSubstr(current,k+1,-1));
                                 s = i + 1;
                                     i = StringFind(EmaPeriods,";",s);
            }
         size = ArrayRange(periods,0);
   
      //
      //
      //
      //
      //
   
   //IndicatorShortName(size+" EMA crossovers");
   string indiName = (string)size+" EMA crossovers";
	IndicatorSetString(INDICATOR_SHORTNAME,indiName);
		
	ArrayResize(macd,ArrayRange(periods,0)+1);
	
	for (int k=0; k<size; k++)
   {

   	macd[k] = iMACD(NULL,0,periods[k][0],periods[k][1],1,PRICE_CLOSE);
	}
	
	
	
	
}
//int OnDeinit(){ return(0); }

//------------------------------------------------------------------
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   indicatorCalc(rates_total,prev_calculated,open,high,low,close); 

   return(rates_total);
}//------------------------------------------------------------------
//
//
//
//
//

int indicatorCalc(int rates_total,int prev_calculated,
const double &open[],const double &high[],const double &low[],const double &close[])
  {
   int counted_bars = prev_calculated;
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars(_Symbol,_Period)-counted_bars,Bars(_Symbol,_Period)-2);

   //
   //
   //
   //
   //
	//for (int k=0; k<size; k++)
   //{
   	//macd[k] = iMACD(NULL,0,periods[k][0],periods[k][1],1,PRICE_CLOSE);
	//}
	
      	double _macd[];
      	ArraySetAsSeries(_macd, true);

   for(int i=limit; i>=0; i--)
   {
      int count = 0;
      for (int k=0; k<size; k++)
      {
         //macd[] = iMACD(NULL,0,periods[k][0],periods[k][1],1,PRICE_CLOSE);
         if (CopyBuffer(macd[k],0,0,i+1,_macd) < 0){Print("CopyBufferMACD error =",GetLastError());}

         double macd_k = _macd[i];
         if (macd_k>0) count++;
         if (macd_k<0) count--;
      }         
      GreenBuffer[i] = EMPTY_VALUE;
      RedBuffer[i]   = EMPTY_VALUE;
      trend[i]        = trend[i+1];
      if (count== size) trend[i] =  1;
      if (count==-size) trend[i] = -1;
      if (trend[i] ==  1) GreenBuffer[i] = 100;
      if (trend[i] == -1) RedBuffer[i]   = 100;
   }
   return(0);
}